Skip to main content

Sendgrid authentication

This page documents the authentication and configuration options for the Sendgrid agent connector.

Authentication

Open source execution

In open source mode, you provide API credentials directly to the connector.

OAuth

This authentication method isn't available for this connector.

Token

credentials fields you need:

Field NameTypeRequiredDescription
api_keystrYesYour SendGrid API key (generated at https://app.sendgrid.com/settings/api_keys)

Example request:

from airbyte_agent_sdk.connectors.sendgrid import SendgridConnector
from airbyte_agent_sdk.connectors.sendgrid.models import SendgridAuthConfig

connector = SendgridConnector(
auth_config=SendgridAuthConfig(
api_key="<Your SendGrid API key (generated at https://app.sendgrid.com/settings/api_keys)>"
)
)

Hosted execution

In hosted mode, you first create a connector via the Airbyte API (providing your OAuth or Token credentials), then execute operations using either the Python SDK or API. If you need a step-by-step guide, see the hosted execution tutorial.

OAuth

This authentication method isn't available for this connector.

Bring your own OAuth flow

This authentication method isn't available for this connector.

Token

Create a connector with Token credentials.

credentials fields you need:

Field NameTypeRequiredDescription
api_keystrYesYour SendGrid API key (generated at https://app.sendgrid.com/settings/api_keys)

replication_config fields you need:

Field NameTypeRequiredDescription
start_datestr (date-time)YesUTC date and time in the format 2017-01-25T00:00:00Z. Any data before this date will not be replicated.

Example request:

curl -X POST "https://api.airbyte.ai/api/v1/integrations/connectors" \
-H "Authorization: Bearer <YOUR_BEARER_TOKEN>" \
-H "Content-Type: application/json" \
-d '{
"workspace_name": "<WORKSPACE_NAME>",
"connector_type": "Sendgrid",
"name": "My Sendgrid Connector",
"credentials": {
"api_key": "<Your SendGrid API key (generated at https://app.sendgrid.com/settings/api_keys)>"
},
"replication_config": {
"start_date": "<UTC date and time in the format 2017-01-25T00:00:00Z. Any data before this date will not be replicated.>"
}
}'

Execution

After creating the connector, execute operations using either the Python SDK or API. If your Airbyte client can access multiple organizations, include organization_id in AirbyteAuthConfig and X-Organization-Id in raw API calls.

Python SDK

The connect() factory returns a fully typed SendgridConnector and reads AIRBYTE_CLIENT_ID / AIRBYTE_CLIENT_SECRET from the environment:

Pydantic AI

Pydantic AI
from airbyte_agent_sdk import connect
from airbyte_agent_sdk.connectors.sendgrid import SendgridConnector

connector = connect("sendgrid", workspace_name="<your_workspace_name>")

@agent.tool_plain
@SendgridConnector.tool_utils
async def sendgrid_execute(entity: str, action: str, params: dict | None = None):
return await connector.execute(entity, action, params or {})

LangChain

LangChain
import json

from langchain_core.tools import tool
from airbyte_agent_sdk import connect
from airbyte_agent_sdk.connectors.sendgrid import SendgridConnector

connector = connect("sendgrid", workspace_name="<your_workspace_name>")

@tool
@SendgridConnector.tool_utils
async def sendgrid_execute(entity: str, action: str, params: dict | None = None) -> str:
"""Execute Sendgrid connector operations."""
result = await connector.execute(entity, action, params or {})
return json.dumps(result, default=str)

FastMCP

FastMCP
import json

from fastmcp import FastMCP
from airbyte_agent_sdk import connect
from airbyte_agent_sdk.connectors.sendgrid import SendgridConnector

connector = connect("sendgrid", workspace_name="<your_workspace_name>")

mcp = FastMCP("Sendgrid Agent")

@mcp.tool()
@SendgridConnector.tool_utils
async def sendgrid_execute(entity: str, action: str, params: dict | None = None) -> str:
"""Execute Sendgrid connector operations."""
result = await connector.execute(entity, action, params or {})
return json.dumps(result, default=str)

Or pass credentials explicitly (equivalent, useful when you're not loading them from the environment): Pydantic AI

Pydantic AI
from airbyte_agent_sdk.connectors.sendgrid import SendgridConnector
from airbyte_agent_sdk.types import AirbyteAuthConfig

connector = SendgridConnector(
auth_config=AirbyteAuthConfig(
workspace_name="<your_workspace_name>",
organization_id="<your_organization_id>", # Optional for multi-org clients
airbyte_client_id="<your-client-id>",
airbyte_client_secret="<your-client-secret>"
)
)

@agent.tool_plain
@SendgridConnector.tool_utils
async def sendgrid_execute(entity: str, action: str, params: dict | None = None):
return await connector.execute(entity, action, params or {})

LangChain

LangChain
import json

from langchain_core.tools import tool
from airbyte_agent_sdk.connectors.sendgrid import SendgridConnector
from airbyte_agent_sdk.types import AirbyteAuthConfig

connector = SendgridConnector(
auth_config=AirbyteAuthConfig(
workspace_name="<your_workspace_name>",
organization_id="<your_organization_id>", # Optional for multi-org clients
airbyte_client_id="<your-client-id>",
airbyte_client_secret="<your-client-secret>"
)
)

@tool
@SendgridConnector.tool_utils
async def sendgrid_execute(entity: str, action: str, params: dict | None = None) -> str:
"""Execute Sendgrid connector operations."""
result = await connector.execute(entity, action, params or {})
return json.dumps(result, default=str)

FastMCP

FastMCP
import json

from fastmcp import FastMCP
from airbyte_agent_sdk.connectors.sendgrid import SendgridConnector
from airbyte_agent_sdk.types import AirbyteAuthConfig

connector = SendgridConnector(
auth_config=AirbyteAuthConfig(
workspace_name="<your_workspace_name>",
organization_id="<your_organization_id>", # Optional for multi-org clients
airbyte_client_id="<your-client-id>",
airbyte_client_secret="<your-client-secret>"
)
)

mcp = FastMCP("Sendgrid Agent")

@mcp.tool()
@SendgridConnector.tool_utils
async def sendgrid_execute(entity: str, action: str, params: dict | None = None) -> str:
"""Execute Sendgrid connector operations."""
result = await connector.execute(entity, action, params or {})
return json.dumps(result, default=str)

API

curl -X POST 'https://api.airbyte.ai/api/v1/integrations/connectors/<connector_id>/execute' \
-H 'Authorization: Bearer <YOUR_BEARER_TOKEN>' \
-H 'X-Organization-Id: <YOUR_ORGANIZATION_ID>' \
-H 'Content-Type: application/json' \
-d '{"entity": "<entity>", "action": "<action>", "params": {}}'